/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { ShapeAxisInfoCache } from "./ShapeAxisInfoCache";
import { StyleSelector } from "./StyleSelector";
import { DependencyProperty } from "igniteui-react-core";
import { Style } from "igniteui-react-core";
import { MarkerType_$type } from "./MarkerType";
import { DataTemplate } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { MarkerOutlineMode_$type } from "./MarkerOutlineMode";
import { MarkerFillMode_$type } from "./MarkerFillMode";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { Base, runOn, enumGetBox, Number_$type, typeCast, fromEnum, markType, markDep, PointUtil } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { OwnedPoint } from "./OwnedPoint";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { Marker } from "./Marker";
import { MarkerSeries } from "./MarkerSeries";
import { BrushUtil } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { HashPool$2 } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { RectUtil } from "igniteui-react-core";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { isNaN_, isInfinity } from "igniteui-react-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { DataTemplateMeasureInfo } from "igniteui-react-core";
import { Size } from "igniteui-react-core";
import { Defaults } from "./Defaults";
import { DataTemplatePassInfo } from "igniteui-react-core";
import { DataTemplateRenderInfo } from "igniteui-react-core";
import { MarkerVisualData } from "./MarkerVisualData";
import { stringIsNullOrEmpty } from "igniteui-react-core";
/**
 * @hidden
 */
var ScatterPolygonSeries = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterPolygonSeries, _super);
    function ScatterPolygonSeries() {
        var _this = _super.call(this) || this;
        _this.aaj = null;
        _this.aag = new ScalerParams(1, ScatterPolygonSeries.abp, ScatterPolygonSeries.abp, false);
        _this.aah = new ScalerParams(1, ScatterPolygonSeries.abp, ScatterPolygonSeries.abp, false);
        _this.aa5 = null;
        _this.aab = 1;
        _this.z7 = 1;
        _this.ab = ScatterPolygonSeries.$;
        return _this;
    }
    ScatterPolygonSeries.prototype.bj = function () {
        return new ScatterPolygonSeries();
    };
    ScatterPolygonSeries.prototype.get_fq = function () {
        return true;
    };
    ScatterPolygonSeries.prototype.get_fl = function () {
        return true;
    };
    ScatterPolygonSeries.prototype.yd = function () {
        return this.aal();
    };
    ScatterPolygonSeries.prototype.zl = function (a) {
        var _this = this;
        var b = a;
        b.cy(this.abr);
        b.cz(this.aak);
        _super.prototype.zl.call(this, a);
        if (this.d5(a)) {
            return;
        }
        var c, d;
        var e = a.getViewInfo(c, d);
        c = e.p0;
        d = e.p1;
        var f = this.getEffectiveViewport1(a);
        this.aag = new ScalerParams(1, d, c, this.xc.ch);
        this.aag.c = f;
        this.aah = new ScalerParams(1, d, c, this.xe.ch);
        this.aah.c = f;
        if (c.width < 1 || c.height < 1) {
            return;
        }
        this.aaj = ((function () {
            var $ret = new ShapeAxisInfoCache();
            $ret.a = _this.xc;
            $ret.b = _this.xe;
            $ret.e = _this.xc.ch;
            $ret.f = _this.xe.ch;
            $ret.d = _this.dn;
            $ret.c = _this.xu;
            return $ret;
        })());
        if (this.aal()) {
            var g = new Dictionary$2(Base.$, OwnedPoint.$, 0);
            b.dg.l(g, 400, d, c, this.id);
            b.dg.j(g, false);
            if (this.yb()) {
                this.aa2(a);
            }
        }
    };
    ScatterPolygonSeries.prototype.aa2 = function (a) {
        var _this = this;
        a.dk = true;
        this.xj.ay(this, this.yb(), runOn(this, this.w2));
        var b = this.xj.d;
        var c = b != null;
        var d = this.getEffectiveViewport1(a);
        var e = this.dn == null ? 0 : this.dn.count;
        a.dw(function (f) {
            if (f._visibility == 0) {
                var g = f.ak;
                var h = f.content;
                if (h == null) {
                    h = new DataContext();
                    f.content = h;
                }
                if (c) {
                    _this.zg(g, e, a.q);
                }
                _this.xj.ac(f, h);
            }
        });
    };
    ScatterPolygonSeries.prototype.aal = function () {
        return this.aa5 != null && ((this.aaf != 1 && this.aaf != 0) || this.aa6 != null);
    };
    ScatterPolygonSeries.prototype.cs = function () {
        return new ScatterPolygonSeriesView(this);
    };
    ScatterPolygonSeries.prototype.qz = function (a) {
        _super.prototype.qz.call(this, a);
        this.aai = a;
    };
    ScatterPolygonSeries.prototype.get_hasMarkers = function () {
        return true;
    };
    ScatterPolygonSeries.prototype.get_el = function () {
        return this.aaf != 13 && this.aaf != 1;
    };
    ScatterPolygonSeries.prototype.vj = function () {
        return this.abl;
    };
    ScatterPolygonSeries.prototype.vk = function () {
        return this.abm;
    };
    ScatterPolygonSeries.prototype.sx = function () {
        return this.aa4;
    };
    ScatterPolygonSeries.prototype.ma = function () {
        return this.mb(this, this.aa5);
    };
    ScatterPolygonSeries.prototype.io = function () {
        return this.aan;
    };
    Object.defineProperty(ScatterPolygonSeries.prototype, "aac", {
        get: function () {
            return this.aab;
        },
        set: function (a) {
            this.aab = a;
        },
        enumerable: false,
        configurable: true
    });
    ScatterPolygonSeries.prototype.aae = function () {
        if (this.aad == 0) {
            return 1;
        }
        return this.aad;
    };
    ScatterPolygonSeries.prototype.sj = function (a) {
        _super.prototype.sj.call(this, a);
        this.aad = a;
    };
    Object.defineProperty(ScatterPolygonSeries.prototype, "z8", {
        get: function () {
            return this.z7;
        },
        set: function (a) {
            this.z7 = a;
        },
        enumerable: false,
        configurable: true
    });
    ScatterPolygonSeries.prototype.aaa = function () {
        if (this.z9 == 0) {
            return 2;
        }
        return this.z9;
    };
    ScatterPolygonSeries.prototype.si = function (a) {
        _super.prototype.si.call(this, a);
        this.z9 = a;
    };
    ScatterPolygonSeries.prototype.sk = function (a) {
        _super.prototype.sk.call(this, a);
        this.aan = a;
    };
    ScatterPolygonSeries.prototype.sf = function () {
        _super.prototype.sf.call(this);
        if (this.index < 0) {
            return;
        }
        if (this.aa6 != null) {
            this.aai.dv();
            this.aai.ds();
        }
        else {
            var a = MarkerSeries.w9(this, this.aaf);
            var b = MarkerSeries.xm(a);
            if (b == null) {
                this.aa4 = MarkerSeries.x1;
            }
            else {
                this.aai.dp(b);
            }
        }
        if (this.abn != null && this.aaf != 13) {
            this.r6("ActualMarkerBrush");
            var c = this.abl;
            this.aai.dt();
            this.aai.dq();
            var d = this.abl;
            var e = this.fh("ActualMarkerBrush", this.hv.f > 0 ? this.hv.d() : null, c, d);
            this.r8("ActualMarkerBrush", e);
        }
        else {
            if (this.aaf == 13) {
                this.abl = this.cv.bt();
            }
            else {
                if (this.z8 != 2) {
                    if (this.db != null) {
                        var f = this.db.ve(this.index);
                        if (!isNaN_(this.ic) && this.ic != 1) {
                            f = BrushUtil.q(f, this.ic);
                        }
                        this.abl = f;
                    }
                    else {
                        this.abl = null;
                    }
                }
            }
        }
        if (this.abo != null) {
            this.aai.du();
            this.aai.dr();
        }
        else {
            if (this.aaf == 13) {
                this.abm = this.cv.bt();
            }
            else {
                if (this.aad == 2) {
                    this.abm = this.abl;
                }
                else {
                    this.abm = this.db == null ? null : this.db.vf(this.index);
                }
            }
        }
        if (this.z8 == 2 && this.abn == null && this.aaf != 13) {
            if (this.abm != null) {
                var g = this.abm;
                if (!isNaN_(this.ic) && this.ic != 1) {
                    g = BrushUtil.q(g, this.ic);
                }
                this.abl = g;
            }
            else {
                this.abl = null;
            }
        }
    };
    ScatterPolygonSeries.prototype.qq = function () {
        _super.prototype.qq.call(this);
        this.aac = this.aae();
        this.z8 = this.aaa();
    };
    ScatterPolygonSeries.prototype.q7 = function (a, b, c, d) {
        _super.prototype.q7.call(this, a, b, c, d);
        switch (b) {
            case ScatterPolygonSeries.$$p[3]:
            case ScatterPolygonSeries.$$p[11]:
            case ScatterPolygonSeries.$$p[7]:
            case ScatterPolygonSeries.$$p[9]:
            case ScatterPolygonSeries.$$p[10]:
                this.rd(b);
                this.q1();
                break;
            case ScatterPolygonSeries.$$p[6]:
                this.aac = this.aae();
                this.rd(null);
                this.q1();
                break;
            case ScatterPolygonSeries.$$p[5]:
                this.z8 = this.aaa();
                this.rd(null);
                this.q1();
                break;
            case ScatterPolygonSeries.$$p[2]:
                this.aa5 = d;
                if (c == MarkerSeries.x1 || d == MarkerSeries.x1 || (c == null || d != null)) {
                    this.aai.dx();
                    this.rp(false);
                }
                this.cv.bl();
                if (this.toolTip != null && this.fi) {
                    this.ba.a$as(this, this.toolTip);
                }
                this.rp(false);
                this.qj();
                break;
            case ScatterPolygonSeries.$$p[12]:
                this.aai.cy(this.abr);
                this.rp(false);
                this.qj();
                break;
            case ScatterPolygonSeries.$$p[13]:
                this.aai.cz(this.aak);
                this.rp(false);
                this.qj();
                break;
            case ScatterPolygonSeries.$$p[4]:
                this.rp(false);
                this.qj();
                break;
            case ScatterPolygonSeries.$$p[0]:
            case ScatterPolygonSeries.$$p[1]:
                if (this.aal()) {
                    this.rp(false);
                }
                break;
        }
    };
    ScatterPolygonSeries.prototype.a2 = function (a, b) {
        var c = this.aai.b4(a);
        var d = null;
        if (c != null) {
            d = c.content;
        }
        if (d != null) {
            return d;
        }
        return _super.prototype.a2.call(this, a, b);
    };
    ScatterPolygonSeries.prototype.aa3 = function (a, b) {
        var e_1, _a, e_2, _b;
        var c = new List$1(Base.$, 0);
        try {
            for (var _c = __values(fromEnum(b.c)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var d = _d.value;
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(c)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var e = _f.value;
                b.h(e);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
    };
    ScatterPolygonSeries.prototype.eb = function (a, b, c, d, e) {
        var _this = this;
        if (!this.hasMarkers) {
            return false;
        }
        var f = this.xc;
        var g = new ScalerParams(1, this.db.v4, this.wq, f.ch);
        g.c = this.getEffectiveViewport1(this.cv);
        var h = this.xe;
        var i = new ScalerParams(1, this.db.v4, this.wq, h.ch);
        i.c = this.getEffectiveViewport1(this.cv);
        a.clear();
        this.aai.dw(function (j) {
            if (j._visibility == 0) {
                var k = new SeriesPointOfInterest();
                var l = j.n;
                var m = j.o;
                if (l < _this.wq.left || l > _this.wq.right || m < _this.wq.top || m > _this.wq.bottom) {
                    return;
                }
                k.d = f.eo(l, g);
                k.e = h.eo(m, i);
                k.b = j.content;
                k.g = _this.ve;
                k.c = j.ak;
                if (_this.g9) {
                    k.g = _this.vl(j.ak);
                }
                a.add(k);
            }
        });
        return true;
    };
    ScatterPolygonSeries.prototype.z5 = function (a, b, c, d, e) {
        var _this = this;
        if (c == null || c.length != this.aaj.d.count) {
            c = new Array(this.aaj.d.count);
            for (var f = 0; f < this.aaj.d.count; f++) {
                c[f] = PointUtil.create();
            }
        }
        var g = ((function () {
            var $ret = new ScalerParams(1, d, e, _this.xc.ch);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var h = ((function () {
            var $ret = new ScalerParams(1, d, e, _this.xe.ch);
            $ret.c = _this.getEffectiveViewport1(a);
            return $ret;
        })());
        var i = this.wh(a);
        var j = this.aaj.a.eo(i.left, g);
        var k = this.aaj.a.eo(i.right, g);
        var l = this.aaj.b.eo(i.bottom, h);
        var m = this.aaj.b.eo(i.top, h);
        if (this.aaj.e) {
            var n = j;
            j = k;
            k = n;
        }
        if (this.aaj.f) {
            var o = l;
            l = m;
            m = o;
        }
        var p = this.aaj;
        var q = p.a;
        var r = p.b;
        var s;
        var t;
        var u = g.d.left;
        var v = g.d.right;
        var w = h.d.top;
        var x = h.d.bottom;
        for (var y = 0; y < this.aaj.d.count; y++) {
            s = 0;
            t = 0;
            var z = null;
            var aa = a.cc.tryGetValue(y, z);
            z = aa.p1;
            if (z == null) {
                c[y].x = NaN;
                c[y].y = NaN;
            }
            else {
                var ab = z.c;
                var ac = RectUtil.l(ab);
                s = ac.x;
                t = ac.y;
                if (s >= u && s <= v && t >= w && t <= x) {
                    c[y].x = s;
                    c[y].y = t;
                }
                else {
                    c[y].x = NaN;
                    c[y].y = NaN;
                }
            }
        }
        return c;
    };
    ScatterPolygonSeries.prototype.aam = function (a, b) {
        var e_3, _a;
        if (b == null) {
            b = new List$1(Number_$type, 2, a.e);
        }
        else {
            b.clear();
        }
        var c = 0;
        var d = this.dn;
        try {
            for (var _b = __values(fromEnum(a.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                b.add(d.indexOf(e));
                c++;
            }
        }
        catch (e_3_1) {
            e_3 = { error: e_3_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_3)
                    throw e_3.error;
            }
        }
        return b;
    };
    ScatterPolygonSeries.prototype.ak = function (a, b) {
        var c = new List$1(ChartSelection.$, 0);
        this.p2(a, c, b);
        return c.toArray();
    };
    ScatterPolygonSeries.prototype.p2 = function (a, b, c) {
        this.zd(a, b, c);
    };
    ScatterPolygonSeries.$t = markType(ScatterPolygonSeries, 'ScatterPolygonSeries', ShapeSeriesBase.$);
    ScatterPolygonSeries.abp = new Rect(0, 0, 0, 1, 1);
    ScatterPolygonSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterPolygonSeries, 'raisePropertyChanged', ['ActualMarkerBrush:abl:aa7', [Brush.$], 'ActualMarkerOutline:abm:aa8', [Brush.$], 'ActualMarkerTemplate:aa4:aa9', [DataTemplate.$, null], 'MarkerBrush:abn:aba', [Brush.$], 'MarkerCollisionAvoidance:z6:abb', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:z9:abc', [MarkerFillMode_$type, enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:aad:abd', [MarkerOutlineMode_$type, enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:abo:abe', [Brush.$], 'MarkerStyle:abq:abf', [Style.$], 'MarkerTemplate:aa6:abg', [DataTemplate.$, null], 'MarkerThickness:aan:abh', [1, DeviceUtils.g(2)], 'MarkerType:aaf:abi', [MarkerType_$type, enumGetBox(MarkerType_$type, 1)], 'ShapeStyle:abr:abj', [Style.$, null], 'ShapeStyleSelector:aak:abk', [StyleSelector.$, null]]);
    return ScatterPolygonSeries;
}(ShapeSeriesBase));
export { ScatterPolygonSeries };
/**
 * @hidden
 */
var ScatterPolygonSeriesView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ScatterPolygonSeriesView, _super);
    function ScatterPolygonSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.dk = false;
        _this.db = null;
        _this.dm = null;
        _this.dh = null;
        _this.df = null;
        _this.dj = false;
        _this.di = null;
        _this.dn = null;
        _this.dc = new Marker();
        _this.d4 = null;
        _this.dc = new Marker();
        _this.dc.content = new DataContext();
        _this.dh = a;
        _this.di = new HashPool$2(Base.$, Marker.$);
        _this.dn = new List$1(Marker.$, 0);
        _this.dy(_this.di);
        _this.df = new NumericMarkerManager(1, function (b) { return _this.di.item(b); }, function (b) { return _this.dh.aaj.d.item(b); }, runOn(_this, _this.d2), runOn(_this, _this.da), runOn(_this, _this.dl), function () { return _this.dh.z6; });
        _this.df.q = runOn(_this, _this.d5);
        return _this;
    }
    ScatterPolygonSeriesView.prototype.au = function () {
        _super.prototype.au.call(this);
        if (!this.q) {
            this.dh.abo = Defaults.am;
            this.dh.jp = Defaults.z;
            this.dh.aan = Defaults.y;
            this.dh.aaf = Defaults.f;
            this.dh.z9 = Defaults.b;
        }
    };
    Object.defineProperty(ScatterPolygonSeriesView.prototype, "dg", {
        get: function () {
            return this.df;
        },
        enumerable: false,
        configurable: true
    });
    ScatterPolygonSeriesView.prototype.d2 = function (a) {
        this.dh.aa3(a, this.di);
    };
    ScatterPolygonSeriesView.prototype.da = function () {
        this.db = this.dh.z5(this, this.di, this.db, this.by, this.bx);
        return this.db;
    };
    ScatterPolygonSeriesView.prototype.dl = function () {
        this.dm = this.dh.aam(this.di, this.dm);
        return this.dm;
    };
    ScatterPolygonSeriesView.prototype.c5 = function (a, b) {
        return this.c6(a, b, true);
    };
    ScatterPolygonSeriesView.prototype.cm = function (a, b, c) {
        _super.prototype.cm.call(this, a, b, c);
        ShapeSeriesViewBase.cl(this, a, b);
    };
    ScatterPolygonSeriesView.prototype.ck = function (a, b) {
        var c = a;
        if (c == null) {
            return;
        }
        c.an = b;
    };
    ScatterPolygonSeriesView.prototype.dw = function (a) {
        this.di.f(a);
    };
    ScatterPolygonSeriesView.prototype.dy = function (a) {
        a.create = runOn(this, this.de);
        a.destroy = runOn(this, this.d0);
        a.activate = runOn(this, this.dz);
        a.disactivate = runOn(this, this.d1);
    };
    ScatterPolygonSeriesView.prototype.de = function () {
        var _this = this;
        var a = new Marker();
        if (!this.dj) {
            a.content = ((function () {
                var $ret = new DataContext();
                $ret.series = _this.e;
                return $ret;
            })());
        }
        a.ah = this.e.aa4;
        this.dn.add(a);
        return a;
    };
    ScatterPolygonSeriesView.prototype.b4 = function (a) {
        var b = this.dd(a, 0);
        if (b == null) {
            b = this.dd(a, 3);
        }
        return b;
    };
    ScatterPolygonSeriesView.prototype.dd = function (a, b) {
        var c;
        var d;
        var e;
        var f;
        for (var g = this.dn.count - 1; g >= 0; g--) {
            var h = this.dn._inner[g];
            if (h._visibility == 1 || h._opacity == 0) {
                continue;
            }
            c = (h.m / 2) + b;
            d = (h.l / 2) + b;
            e = h.ai;
            f = h.aj;
            if ((h.n + e) - c <= a.x && (h.n + e) + c >= a.x && (h.o + f) - d <= a.y && (h.o + f) + d >= a.y) {
                return h;
            }
        }
        return null;
    };
    ScatterPolygonSeriesView.prototype.d0 = function (a) {
        a.content = null;
        this.dn.remove(a);
    };
    ScatterPolygonSeriesView.prototype.dz = function (a) {
        a._visibility = 0;
    };
    ScatterPolygonSeriesView.prototype.d1 = function (a) {
        if (a.content != null) {
            (typeCast(DataContext.$, a.content)).item = null;
        }
        a._visibility = 1;
    };
    ScatterPolygonSeriesView.prototype.d3 = function (a) {
        this.dj = a;
    };
    ScatterPolygonSeriesView.prototype.bj = function (a, b) {
        _super.prototype.bj.call(this, a, b);
        if (!this.dk) {
            var c = a;
            var d = c.content;
            if (d != null) {
                if (this.dh.abl != null) {
                    d.actualItemBrush = this.dh.abl;
                }
                else {
                    d.actualItemBrush = this.b6.u7;
                }
                if (this.dh.abl != null) {
                    d.outline = this.dh.abm;
                }
                else {
                    d.outline = this.b6.vb;
                }
                d.thickness = this.dh.aan;
            }
        }
    };
    ScatterPolygonSeriesView.prototype.bk = function (a, b) {
        _super.prototype.bk.call(this, a, b);
        var c = a;
        this.dc._visibility = c._visibility;
        this.dc.ah = c.ah;
        this.dc.width = c.width;
        this.dc.height = c.height;
        this.dc.m = c.m;
        this.dc.l = c.l;
        this.dc.n = c.n;
        this.dc.o = c.o;
        var d = this.bs(b);
        var e = this.dc.content;
        var f = c.content;
        e.item = f.item;
        e.series = f.series;
        e.thickness = f.thickness;
        if (e != null) {
            e.actualItemBrush = d;
            e.outline = d;
            e.thickness = this.dh.aan + 3;
        }
    };
    ScatterPolygonSeriesView.prototype.a7 = function (a, b) {
        _super.prototype.a7.call(this, a, b);
        var c = new DataTemplatePassInfo();
        c.isHitTestRender = b;
        c.context = a.h();
        c.viewportTop = this.bx.top;
        c.viewportLeft = this.bx.left;
        c.viewportWidth = this.bx.width;
        c.viewportHeight = this.bx.height;
        c.passID = "Markers";
        var d = new DataTemplateRenderInfo();
        d.passInfo = c;
        d.isHitTestRender = b;
        var e = new DataTemplateMeasureInfo();
        e.passInfo = c;
        var f = false;
        var g = a.h();
        e.context = g;
        d.context = g;
        var h = 0;
        var i = 0;
        if (this.dh.aa4 != null && this.dh.aa4.passStarting != null) {
            this.dh.aa4.passStarting(c);
        }
        for (var j = 0; j < this.dn.count; j++) {
            var k = this.dn._inner[j];
            if (k._visibility == 1) {
                continue;
            }
            this.bi(k, j, b);
            if (b) {
                k = this.dc;
            }
            if (!f) {
                e.width = k.width;
                e.height = k.height;
                e.renderOffsetX = 0;
                e.renderOffsetY = 0;
                e.renderContext = a;
                var l = k.ah;
                if (l.measure != null) {
                    e.data = k.content;
                    l.measure(e);
                    f = e.isConstant;
                    if (f) {
                        h = e.width;
                        i = e.height;
                    }
                }
                d.availableWidth = e.width;
                d.availableHeight = e.height;
                d.renderOffsetX = e.renderOffsetX;
                d.renderOffsetY = e.renderOffsetY;
                d.renderContext = a;
            }
            else {
                d.availableWidth = h;
                d.availableHeight = i;
            }
            if (!isNaN_(k.width) && !isInfinity(k.width)) {
                d.availableWidth = k.width;
            }
            if (!isNaN_(k.height) && !isInfinity(k.height)) {
                d.availableHeight = k.height;
            }
            a.q(d, k);
            k.m = d.availableWidth;
            k.l = d.availableHeight;
            k.ai = d.renderOffsetX;
            k.aj = d.renderOffsetY;
        }
        if (this.dh.aa4 != null && this.dh.aa4.passCompleted != null) {
            this.dh.aa4.passCompleted(c);
        }
    };
    ScatterPolygonSeriesView.prototype.dv = function () {
        this.dh.aa4 = null;
    };
    ScatterPolygonSeriesView.prototype.ds = function () {
        this.dh.aa4 = null;
        this.dh.aa4 = this.dh.aa6;
    };
    ScatterPolygonSeriesView.prototype.dt = function () {
        this.dh.abl = null;
    };
    ScatterPolygonSeriesView.prototype.dq = function () {
        this.dh.abl = null;
        if (!isNaN_(this.e.ic) && this.e.ic != 1) {
            var a = BrushUtil.q(this.dh.abn, this.e.ic);
            this.dh.abl = a;
        }
        else {
            this.dh.abl = this.dh.abn;
        }
    };
    ScatterPolygonSeriesView.prototype.du = function () {
        this.dh.abm = null;
    };
    ScatterPolygonSeriesView.prototype.dr = function () {
        this.dh.abm = null;
        this.dh.abm = this.dh.abo;
    };
    ScatterPolygonSeriesView.prototype.dp = function (a) {
        switch (a) {
            case "CircleMarkerTemplate":
                this.dh.aa4 = this.dh.db.r1;
                break;
            case "TriangleMarkerTemplate":
                this.dh.aa4 = this.dh.db.sa;
                break;
            case "PyramidMarkerTemplate":
                this.dh.aa4 = this.dh.db.r7;
                break;
            case "SquareMarkerTemplate":
                this.dh.aa4 = this.dh.db.r8;
                break;
            case "DiamondMarkerTemplate":
                this.dh.aa4 = this.dh.db.r2;
                break;
            case "PentagonMarkerTemplate":
                this.dh.aa4 = this.dh.db.r5;
                break;
            case "HexagonMarkerTemplate":
                this.dh.aa4 = this.dh.db.r3;
                break;
            case "TetragramMarkerTemplate":
                this.dh.aa4 = this.dh.db.r5;
                break;
            case "PentagramMarkerTemplate":
                this.dh.aa4 = this.dh.db.r6;
                break;
            case "HexagramMarkerTemplate":
                this.dh.aa4 = this.dh.db.r4;
                break;
        }
    };
    ScatterPolygonSeriesView.prototype.dx = function () {
        var e_4, _a;
        try {
            for (var _b = __values(fromEnum(this.dn)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var a = _c.value;
                a.ah = this.dh.aa4;
            }
        }
        catch (e_4_1) {
            e_4 = { error: e_4_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_4)
                    throw e_4.error;
            }
        }
        this.as();
    };
    ScatterPolygonSeriesView.prototype.d5 = function (a) {
        if (this.d4 == null) {
            this.d4 = new DataTemplateMeasureInfo();
            this.d4.context = this.k.h();
        }
        this.d4.width = a.width;
        this.d4.height = a.height;
        this.d4.data = a.content;
        var b = a.ah;
        if (b.measure != null) {
            b.measure(this.d4);
        }
        return new Size(1, this.d4.width, this.d4.height);
    };
    ScatterPolygonSeriesView.prototype.an = function (a) {
        var e_5, _a;
        var b = a;
        _super.prototype.an.call(this, b);
        try {
            for (var _b = __values(fromEnum(this.di.c)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var c = _c.value;
                var d = this.di.item(c);
                if (d._visibility != 1) {
                    var e = typeCast(ScatterPolygonSeries.$, this.e);
                    var f = this.e.bc.getMarkerVisualData(e, d, e.aa4);
                    b.markerShapes.add(typeCast(MarkerVisualData.$, f));
                }
            }
        }
        catch (e_5_1) {
            e_5 = { error: e_5_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_5)
                    throw e_5.error;
            }
        }
    };
    ScatterPolygonSeriesView.prototype.getDefaultTooltipTemplate = function () {
        var a = "<div class='ui-chart-default-tooltip-content'><span";
        var b = this.e.ba.a$u(this.e);
        if (!stringIsNullOrEmpty(b)) {
            a += " style='color:" + b + "'";
        }
        a += ">" + this.dh.title + "</span><br/>";
        a += "</div>";
        return a;
    };
    ScatterPolygonSeriesView.$t = markType(ScatterPolygonSeriesView, 'ScatterPolygonSeriesView', ShapeSeriesViewBase.$);
    return ScatterPolygonSeriesView;
}(ShapeSeriesViewBase));
export { ScatterPolygonSeriesView };
